/////////////////////////////////////////////////////////////////////
//
// CN[h
//
/////////////////////////////////////////////////////////////////////
#include "rmf/rmf_abilitybase"

/////////////////////////////////////////////////////////////////////
//
// 萔
//
/////////////////////////////////////////////////////////////////////
#define PL_NAME "[RMF] After Burner"
#define PL_DESC "AfterBurner"
#define PL_VERSION "2013.01.27"

/////////////////////////////////////////////////////////////////////
//
// MOD
//
/////////////////////////////////////////////////////////////////////
public Plugin:myinfo = 
{
	name = PL_NAME,
	author = "RIKUSYO",
	description = PL_DESC,
	version = PL_VERSION,
	url = "http://steamcommunity.com/id/rikusyo/"
}


/////////////////////////////////////////////////////////////////////
//
// fATEhAGtFNg
//
/////////////////////////////////////////////////////////////////////
#define SOUND_BURNER_START	"weapons/flame_thrower_airblast.wav"
#define SOUND_BURNER_LOOP	"weapons/flame_thrower_loop.wav"
#define SOUND_BURNER_END	"weapons/flame_thrower_end.wav"
#define SOUND_BURNER_EMPTY	"weapons/syringegun_reload_air2.wav"
#define SOUND_BURNER_VOICE	"vo/pyro_laughevil01.wav"

#define EFFECT_BURNER_RED	"flamethrower_crit_red"
#define EFFECT_BURNER_BLU	"flamethrower_crit_blue"
#define EFFECT_BURNER_EMPTY	"muzzle_minigun"
#define EFFECT_BURNER_WARP	"pyro_blast_warp"
#define EFFECT_BURNER_WARP2	"pyro_blast_warp2"

/////////////////////////////////////////////////////////////////////
//
// O[oϐ
//
/////////////////////////////////////////////////////////////////////
new bool:g_BurnerState[MAXPLAYERS+1] = false;		// o[i[̏
new g_BurnerParticle[MAXPLAYERS+1] = -1;			// o[i[̃GtFNgGeBeB
new g_BurnerCount[MAXPLAYERS+1] = 0;				// o[i[̃JEg

new bool:g_FirstJump[MAXPLAYERS+1] = false;			// WvH
new bool:g_ReleaseButton[MAXPLAYERS+1] = false;		// L[͂ȂH
new bool:g_AlreadyBurnered[MAXPLAYERS+1] = false;		// L[͂ȂH

/////////////////////////////////////////////////////////////////////
//
// ConVarnh
//
/////////////////////////////////////////////////////////////////////
new Handle:g_CVarAmmoCount	= INVALID_HANDLE;		// e
new Handle:g_CVarUpMulti	= INVALID_HANDLE;		// ㏸{
new Handle:g_CVarFallMulti	= INVALID_HANDLE;		// {
new Handle:g_CVarBurnEnemy	= INVALID_HANDLE;		// R邩ǂ


/////////////////////////////////////////////////////////////////////
//
// vOCJn
//
/////////////////////////////////////////////////////////////////////
public OnPluginStart()
{
	/////////////////////////////////////////////////////////////////////
	// ConVar
	/////////////////////////////////////////////////////////////////////
	CVarInit( PL_NAME, PL_VERSION );

	/////////////////////////////////////////////////////////////////////
	// ConVaro^
	/////////////////////////////////////////////////////////////////////
	AddCVar( g_CVarAmmoCount,	"use_ammo",		"4",	"Ammo required",							0, "0",		"200",	FMT_Int);
	AddCVar( g_CVarUpMulti,		"up_mag",		"1.45",	"Up velocity magnification",				0, "0.0",	"10.0",	FMT_Float);
	AddCVar( g_CVarFallMulti,	"fall_mag",		"0.85",	"Fall velocity magnification",				0, "0.0",	"10.0",	FMT_Float);
	AddCVar( g_CVarBurnEnemy,	"burn_enemy",	"1",	"Burn enemy when hit After Burner's flame",	0, "0",		"1",	FMT_Bool);
	
	/////////////////////////////////////////////////////////////////////
	// Cxgo^
	/////////////////////////////////////////////////////////////////////
	HookEvent( "player_spawn", 		EventPlayerReset, 	EventHookMode_Post);	// vC[
	HookEvent( "player_death", 		EventPlayerReset, 	EventHookMode_Post);	// vC[S

	/////////////////////////////////////////////////////////////////////
	// p[eBN
	/////////////////////////////////////////////////////////////////////
	for (new i = 1; i <= MAXPLAYERS; i++)
	{
		DeleteBurnerParticle(i);
	}

}
/////////////////////////////////////////////////////////////////////
//
// vOCJn
//
/////////////////////////////////////////////////////////////////////
public OnPluginEnd()
{
	/////////////////////////////////////////////////////////////////////
	// p[eBN
	/////////////////////////////////////////////////////////////////////
	for (new i = 1; i <= MAXPLAYERS; i++)
	{
		DeleteBurnerParticle(i);
	}
	
}

/////////////////////////////////////////////////////////////////////
//
// SẴvOCǂݏIĂ瓮
//
/////////////////////////////////////////////////////////////////////
public OnAllPluginsLoaded()
{
	/////////////////////////////////////////////////////////////////////
	// AreBo^
	/////////////////////////////////////////////////////////////////////
	AddAbility( TFClassType:TFClass_Pyro );
	
	/////////////////////////////////////////////////////////////////////
	// K{ACeo^
	/////////////////////////////////////////////////////////////////////
	AddReqItems( "The Backburner", "0" );

	/////////////////////////////////////////////////////////////////////
	// JX^Agr[go^
	/////////////////////////////////////////////////////////////////////
}

/////////////////////////////////////////////////////////////////////
//
// }bvJn
//
/////////////////////////////////////////////////////////////////////
public OnMapStart()
{
	/////////////////////////////////////////////////////////////////////
	// p[eBN
	/////////////////////////////////////////////////////////////////////
	for (new i = 1; i <= MAXPLAYERS; i++)
	{
		DeleteBurnerParticle(i);
	}

	/////////////////////////////////////////////////////////////////////
	// TEhvLbV
	/////////////////////////////////////////////////////////////////////
	PrecacheSound(SOUND_BURNER_START, true);
	PrecacheSound(SOUND_BURNER_LOOP, true);
	PrecacheSound(SOUND_BURNER_END, true);
	PrecacheSound(SOUND_BURNER_EMPTY, true);
	PrecacheSound(SOUND_BURNER_VOICE, true);
}

/////////////////////////////////////////////////////////////////////
//
// Cxg(player_spawn/player_death) ef[^Zbg
//
/////////////////////////////////////////////////////////////////////
public Action:EventPlayerReset(Handle:event, const String:name[], bool:dontBroadcast)
{
	/////////////////////////////////////////////////////////////////////
	// NCAgid
	/////////////////////////////////////////////////////////////////////
	new client = GetClientOfUserId( GetEventInt( event, "userid" ) );
	if( client <= 0 )
	{
		return Plugin_Continue;
	}
	
	/////////////////////////////////////////////////////////////////////
	// fbhK[͔̎
	/////////////////////////////////////////////////////////////////////
	if( StrEqual( name, "player_death" ) )
	{
		new bool:DeadRingered = bool:(GetEventInt(event, "death_flags") & TF_DEATHFLAG_DEADRINGER);
		if( DeadRingered )
		{
			return Plugin_Continue;
		}
	}
	
	/////////////////////////////////////////////////////////////////////
	// f[^Zbg
	/////////////////////////////////////////////////////////////////////
	g_BurnerState[client]=false;
	DeleteBurnerParticle(client);	
	StopSound(client, 0, SOUND_BURNER_LOOP);
	g_FirstJump[client] = false;
	g_ReleaseButton[client] = false;
	g_AlreadyBurnered[client] = false;
	
	return Plugin_Continue;
}

/////////////////////////////////////////////////////////////////////
//
// Q[t[
//
/////////////////////////////////////////////////////////////////////
public OnGameFrame()
{
	/////////////////////////////////////////////////////////////////////
	// NCAgS
	/////////////////////////////////////////////////////////////////////
	new maxclients = GetMaxClients();
	for (new client = 1; client <= maxclients; client++)
	{
		/////////////////////////////////////////////////////////////////////
		// NCAgS
		/////////////////////////////////////////////////////////////////////
		if( IsValidClient( client, false ) && IsPlayerAlive(client) )
		{
			/////////////////////////////////////////////////////////////////////
			// ̃AreBI𒆁H
			/////////////////////////////////////////////////////////////////////
			if( IsSelectedAbility( client ) )
			{
				/////////////////////////////////////////////////////////////////////
				// \̓ANV
				/////////////////////////////////////////////////////////////////////
				AfterBurner(client);
			}
		}
	}
}


/////////////////////////////////////////////////////////////////////
//
// pCAt^[o[i[
//
/////////////////////////////////////////////////////////////////////
public AfterBurner(any:client)
{
	/////////////////////////////////////////////////////////////////////
	// L[`FbN
	/////////////////////////////////////////////////////////////////////
	if( !CheckElapsedTime(client, 0.09) )
	{
		return;
	}

	/////////////////////////////////////////////////////////////////////
	// Wv{^Ă
	/////////////////////////////////////////////////////////////////////
	if ( GetClientButtons(client) & IN_JUMP )
	{
		/////////////////////////////////////////////////////////////////////
		// L[Ԃۑ
		/////////////////////////////////////////////////////////////////////
		SaveKeyTime(client);

		/////////////////////////////////////////////////////////////////////
		// nʂ痣Ă
		/////////////////////////////////////////////////////////////////////
		if( !( GetEntityFlags(client) & FL_ONGROUND ) )
		{
			/////////////////////////////////////////////////////////////////////
			// ܂ł̃JEgON
			/////////////////////////////////////////////////////////////////////
			g_BurnerCount[client] += 1;

			/////////////////////////////////////////////////////////////////////
			// ŏ̃WvŃ{^H
			/////////////////////////////////////////////////////////////////////
			if( g_FirstJump[client] && g_ReleaseButton[client] )
			{
				/////////////////////////////////////////////////////////////////////
				// e֌W
				/////////////////////////////////////////////////////////////////////
				new offset = FindDataMapOffs(client, "m_iAmmo") + (1 * 4);
				new nowAmmo = GetEntData(client, offset, 4);

				/////////////////////////////////////////////////////////////////////
				// At^[o[i[̎
				/////////////////////////////////////////////////////////////////////
				if( !g_BurnerState[client] )
				{
					/////////////////////////////////////////////////////////////////////
					// e򂪂
					/////////////////////////////////////////////////////////////////////
					if( nowAmmo > 0)
					{
						/////////////////////////////////////////////////////////////////////
						// gp
						/////////////////////////////////////////////////////////////////////
						g_BurnerState[client] = true;
						
						/////////////////////////////////////////////////////////////////////
						// Ə㏸
						/////////////////////////////////////////////////////////////////////
						new Float:fVelocity[3];
						GetEntPropVector(client, Prop_Data, "m_vecAbsVelocity", fVelocity);
						if(fVelocity[2] >= -300.0 && !g_AlreadyBurnered[client])
						{
							fVelocity[2] = 250.0;
							SetEntPropVector(client, Prop_Data, "m_vecAbsVelocity", fVelocity);
						}
						
						/////////////////////////////////////////////////////////////////////
						// ÕTEh~߂ĐVȃTEhĐ
						/////////////////////////////////////////////////////////////////////
						StopSound(client, 0, SOUND_BURNER_START);
						EmitSoundToAll(SOUND_BURNER_START, client, _, _, SND_CHANGEPITCH, 0.3, 150);
						CreateTimer(0.02, Timer_StartBurnerLoopSound, client);

						/////////////////////////////////////////////////////////////////////
						// GtFNgݒ
						/////////////////////////////////////////////////////////////////////
						EmptyBurnerEffect(client);
						SetBurnerParticle(client);
						
						/////////////////////////////////////////////////////////////////////
						// GtFNg
						/////////////////////////////////////////////////////////////////////
						new Float:ang[3];
						ang[0] = -25.0;
						ang[1] = 90.0;
						new Float:pos[3];
						pos[1] = 10.0;
						pos[2] = 1.0;
						
						SpawnParticle( EFFECT_BURNER_EMPTY, 0.15, _, client, "flag", pos, ang, _ );	
						SpawnParticle( EFFECT_BURNER_WARP, 0.15, _, client, "flag", pos, ang, _ );	
						SpawnParticle( EFFECT_BURNER_WARP2, 0.15, _, client, "flag", pos, ang, _ );	

						/////////////////////////////////////////////////////////////////////
						// e
						/////////////////////////////////////////////////////////////////////
						nowAmmo -= GetConVarInt(g_CVarAmmoCount);
						if(nowAmmo < 0)
						{
							nowAmmo = 0;
						}
						SetEntData(client, offset, nowAmmo);
					}
					/////////////////////////////////////////////////////////////////////
					// e򖳂Ƃ̓GtFNg~߂
					/////////////////////////////////////////////////////////////////////
					else
					{
						g_BurnerCount[client] = 0;
						g_BurnerState[client] = false;
						DeleteBurnerParticle(client);
						if( !g_AlreadyBurnered[client] )
						{
							StopSound(client, 0, SOUND_BURNER_LOOP);
							StopSound(client, 0, SOUND_BURNER_END);
							StopSound(client, 0, SOUND_BURNER_EMPTY);
							EmitSoundToAll(SOUND_BURNER_END, client, _, _, SND_CHANGEPITCH, 0.3, 120);
							EmitSoundToAll(SOUND_BURNER_EMPTY, client, _, _, SND_CHANGEPITCH, 0.4, 80);
							EmptyBurnerEffect(client);
						}
					}
					g_AlreadyBurnered[client] = true;
				}
				/////////////////////////////////////////////////////////////////////
				// At^[o[i[gp̎
				/////////////////////////////////////////////////////////////////////
				else
				{
					/////////////////////////////////////////////////////////////////////
					// e򂪂ĐȂ
					/////////////////////////////////////////////////////////////////////
					if( nowAmmo > 0 && !( GetEntityFlags( client ) & FL_INWATER ) )
					{
						
						/////////////////////////////////////////////////////////////////////
						// e
						/////////////////////////////////////////////////////////////////////
						nowAmmo -= GetConVarInt(g_CVarAmmoCount);
						if(nowAmmo < 0)
						{
							nowAmmo = 0;
						}
						SetEntData(client, offset, nowAmmo);

						/////////////////////////////////////////////////////////////////////
						// ㏸~
						/////////////////////////////////////////////////////////////////////
						new Float:fVelocity[3];
						GetEntPropVector(client, Prop_Data, "m_vecAbsVelocity", fVelocity);
						if(fVelocity[2] >= 0)
						{
							if(fVelocity[2] < 230.0)
							{
								fVelocity[2] *= GetConVarFloat(g_CVarUpMulti);
							}
						}
						else
						{
							fVelocity[2] *= GetConVarFloat(g_CVarFallMulti);
						}
						SetEntPropVector(client, Prop_Data, "m_vecAbsVelocity", fVelocity);
						
						
						/////////////////////////////////////////////////////////////////////
						// ^̓GRH
						/////////////////////////////////////////////////////////////////////
						if( GetConVarBool( g_CVarBurnEnemy ) )
						{
							new Float:clientPos[3];
							new Float:clientAng[3];
							new Float:hitPos[3];
							new hitEnt = -1;
							
							GetEntPropVector( client, Prop_Send, "m_vecOrigin", clientPos);
							GetEntPropVector( client, Prop_Send, "m_angRotation", clientAng);
							clientAng[0] += 45.0;
							clientAng[1] += 150.0;
							
							/////////////////////////////////////////////////////////////////////
							// g[X
							/////////////////////////////////////////////////////////////////////
							new bool:bHit = HitCheck( clientPos, clientAng, hitPos, MASK_SHOT, hitEnt, AfterBurnerTraceFilter, 0 );
							
							/////////////////////////////////////////////////////////////////////
							// qbg`FbN
							/////////////////////////////////////////////////////////////////////
							if( bHit && GetVectorDistanceMeter(clientPos, hitPos) < 6.0)
							{
								new maxclients = GetMaxClients();
								for (new i = 1; i <= maxclients; i++)
								{
									/////////////////////////////////////////////////////////////////////
									// Ă鑊̂
									/////////////////////////////////////////////////////////////////////
									if( IsValidClient( i, false ) && IsPlayerAlive( i ) )
									{
										/////////////////////////////////////////////////////////////////////
										// ȊO̓G`[
										/////////////////////////////////////////////////////////////////////
										if(client != i && !IsSameTeam( client, i ) )
										{
											new Float:hitPos2[3];
											new hitEnt2 = -1;
											
											new Float:victimPos[3];											
											new Float:victimAng[3];											
											GetEntPropVector( i, Prop_Send, "m_vecOrigin", victimPos);
											hitPos[2] += 10.0;
											victimPos[2] += 50.0;
											SubtractVectors( victimPos, hitPos, victimAng );
											NormalizeVector( victimAng, victimAng );
											GetVectorAngles(victimAng, victimAng);
											bHit = HitCheck( hitPos, victimAng, hitPos2, MASK_SHOT,  hitEnt2, AfterBurnerTraceFilter2, client );
											if( hitEnt2 == i && GetVectorDistanceMeter(hitPos, hitPos2) < 2.0 )
											{
												TF2_IgnitePlayer(i, client);
											}
										}
										
									}
								}
							}
						}
						
					}
					/////////////////////////////////////////////////////////////////////
					// eȂΎ~߂
					/////////////////////////////////////////////////////////////////////
					else
					{
						g_BurnerCount[client] = 0;
						g_BurnerState[client] = false;
						DeleteBurnerParticle(client);
						StopSound(client, 0, SOUND_BURNER_LOOP);
						EmitSoundToAll(SOUND_BURNER_END, client, _, _, SND_CHANGEPITCH, 0.3, 120);
						EmitSoundToAll(SOUND_BURNER_EMPTY, client, _, _, SND_CHANGEPITCH, 0.4, 80);
						EmptyBurnerEffect(client);
					}

				}
			}
			/////////////////////////////////////////////////////////////////////
			// WvI
			/////////////////////////////////////////////////////////////////////
			g_FirstJump[client] = true;

		}
		else
		{
			g_FirstJump[client] = false;
		}

	}
	/////////////////////////////////////////////////////////////////////
	// Wv{^Ă
	/////////////////////////////////////////////////////////////////////
	else
	{
		/////////////////////////////////////////////////////////////////////
		// Wvς݁H
		/////////////////////////////////////////////////////////////////////
		if( g_FirstJump[client] )
		{
			g_ReleaseButton[client] = true;
		}

	}
	
	/////////////////////////////////////////////////////////////////////
	// nʂɒnƐ͖
	/////////////////////////////////////////////////////////////////////
	if( (GetEntityFlags(client) & FL_ONGROUND) || (GetEntityFlags(client) & FL_INWATER))
	{
		g_FirstJump[client] = false;
		g_ReleaseButton[client] = false;
		g_AlreadyBurnered[client] = false;
	}
	
	/////////////////////////////////////////////////////////////////////
	// ĂȂΎ~߂
	/////////////////////////////////////////////////////////////////////
	if( !(GetClientButtons(client) & IN_JUMP) || GetEntityFlags(client) & FL_ONGROUND )
	{
		g_BurnerCount[client] = 0;

		if( g_BurnerState[client] )
		{
			g_BurnerState[client] = false;
			DeleteBurnerParticle(client);
			StopSound(client, 0, SOUND_BURNER_LOOP);
			EmitSoundToAll(SOUND_BURNER_END, client, _, _, SND_CHANGEPITCH, 0.3, 120);
		}
	}
}


/////////////////////////////////////////////////////////////////////
//
// g[XtB^
//
/////////////////////////////////////////////////////////////////////
public bool:AfterBurnerTraceFilter( entity, contentsMask )
{
 	return entity > MAXPLAYERS;
}
public bool:AfterBurnerTraceFilter2( entity, contentsMask, any:data )
{
 	return entity != data;
}

	
/////////////////////////////////////////////////////////////////////
//
// p[eBNZbg
//
/////////////////////////////////////////////////////////////////////
public SetBurnerParticle(any:client)
{
	if( client > 0 )
	{
		if( IsClientInGame(client) && GetClientTeam(client) > 1 && TF2_GetPlayerClass( client ) == TFClass_Pyro)
		{	
			new Float:ang[3];
			ang[0] = -25.0;
			ang[1] = 90.0;
			
			if(TFTeam:GetClientTeam(client) == TFTeam_Red)
	    	{
				g_BurnerParticle[client] = SpawnParticle( EFFECT_BURNER_RED, 0.0, _, client, "flag", _, ang, _ );
	    	}
			else
			{
				g_BurnerParticle[client] = SpawnParticle( EFFECT_BURNER_BLU, 0.0, _, client, "flag", _, ang, _ );
				
			}
			
		}
		else
		{
	    	DeleteBurnerParticle(client);
		}
	}

}
/////////////////////////////////////////////////////////////////////
//
// p[eBN폜
//
/////////////////////////////////////////////////////////////////////
stock DeleteBurnerParticle(any:client)
{
	if (g_BurnerParticle[client] != -1)
	{
		if(IsValidEdict(g_BurnerParticle[client]))
		{
			DeleteParticle(g_BurnerParticle[client])
			g_BurnerParticle[client] = -1;
		}
	}
} 

////////////////////////////////////////
//
// ڃGtFNg
//
////////////////////////////////////////
public EmptyBurnerEffect(client)
{
	new Float:ang[3];
	ang[0] = -25.0;
	ang[1] = 90.0;
	new Float:pos[3];
	pos[1] = 10.0;
	pos[2] = 1.0;
	
	SpawnParticle( EFFECT_BURNER_EMPTY, 0.15, _, client, "flag", pos, ang, _ );	
}
/////////////////////////////////////////////////////////////////////
//
// [vTEhJn^C}[
//
/////////////////////////////////////////////////////////////////////
public Action:Timer_StartBurnerLoopSound(Handle:timer, any:client)
{
	if(g_BurnerState[client])
	{
		EmitSoundToAll(SOUND_BURNER_LOOP, client, _, _, SND_CHANGEPITCH, 0.3, 120);
		
		// łɃ{CX
		EmitSoundToAll(SOUND_BURNER_VOICE, client, _, _, SND_CHANGEPITCH, 0.8, 100);
	}
}

