/////////////////////////////////////////////////////////////////////
// Changelog
/////////////////////////////////////////////////////////////////////
// 2013.01.27
// 2014.01.01 - 隠れ中にアイテムが消えていなかったのを修正
// 2014.01.03 - ロッカーの処理を変更。


/////////////////////////////////////////////////////////////////////
//
// インクルード
//
/////////////////////////////////////////////////////////////////////
#include "rmf/rmf_abilitybase"

/////////////////////////////////////////////////////////////////////
//
// 定数
//
/////////////////////////////////////////////////////////////////////
#define PL_NAME "[RMF] Disguise Jutsu"
#define PL_DESC "Disguise Jutsu"
#define PL_VERSION "2014.01.03"

/////////////////////////////////////////////////////////////////////
//
// MOD情報
//
/////////////////////////////////////////////////////////////////////
public Plugin:myinfo = 
{
	name = PL_NAME,
	author = "RIKUSYO",
	description = PL_DESC,
	version = PL_VERSION,
	url = "http://steamcommunity.com/id/rikusyo/"
}


/////////////////////////////////////////////////////////////////////
//
// モデル、サウンド、エフェクト
//
/////////////////////////////////////////////////////////////////////
#define MDL_WOODEN_BARREL "models/props_farm/wooden_barrel.mdl"
#define SOUND_SPAWN_BARREL "items/pumpkin_drop.wav"
#define SOUND_CHARGE_POWER "player/recharged.wav"
#define SOUND_NO_POWER "weapons/medigun_no_target.wav"
#define SOUND_TAUNT "ui/duel_score_behind.wav"
#define EFFECT_BARREL_SPAWN_SMOKE "Explosion_Smoke_1"
#define EFFECT_BARREL_SPAWN_FLASH "Explosion_Flash_1"


/////////////////////////////////////////////////////////////////////
//
// グローバル変数
//
/////////////////////////////////////////////////////////////////////
new g_BarrelModel[MAXPLAYERS+1] = -1;							// モデル
new g_IsBarrelActive[MAXPLAYERS+1] = -1;						// 樽の中？
new Handle:g_HideVoicehTimer[MAXPLAYERS+1] = INVALID_HANDLE;	// ボイスタイマー
new Handle:g_PowerChargeTimer[MAXPLAYERS+1] = INVALID_HANDLE;	// パワーチャージタイマー
new Handle:g_ResupplyTimer[MAXPLAYERS+1] = INVALID_HANDLE;		// リサプライタイマー
new String:SOUND_START_VOICE[5][64];							// 隠れ開始ボイス
new String:SOUND_HIDE_VOICE[5][64];								// 隠れボイス
new String:SOUND_UNHIDE_VOICE[5][64];							// 登場ボイス
new HideVoiceCount = 0;											// ボイスカウント
new g_NowHealth[MAXPLAYERS+1] = 0; 								// 現在のヘルス
new Float:g_NextUseTime[MAXPLAYERS+1] = 0.0; 					// 次に使えるようになるまでの時間
new bool:g_ActionUse[MAXPLAYERS+1] = false;						// アクションアイテム


/////////////////////////////////////////////////////////////////////
//
// ConVarハンドル
//
/////////////////////////////////////////////////////////////////////
new Handle:g_CVarChargeTime	= INVALID_HANDLE;		// ConVarチャージ時間
new Handle:g_CVarTBlastDMG	= INVALID_HANDLE;		// ConVar爆発ダメージ

/////////////////////////////////////////////////////////////////////
//
// ConVar変更
//
/////////////////////////////////////////////////////////////////////
public OnConVarChanged( Handle:convar, const String:oldValue[], const String:newValue[] )
{
	/////////////////////////////////////////////////////////////////////
	// 武器アトリビュート変更のConVarの場合は追加やり直し
	/////////////////////////////////////////////////////////////////////
	if( convar == g_CVarTBlastDMG )
	{
		OnAllPluginsLoaded();
	}
}

/////////////////////////////////////////////////////////////////////
//
// 全てのプラグインが読み終わってから動作
//
/////////////////////////////////////////////////////////////////////
public OnAllPluginsLoaded()
{
	/////////////////////////////////////////////////////////////////////
	// アビリティ登録
	/////////////////////////////////////////////////////////////////////
	AddAbility( TFClassType:TFClass_Pyro );
	
	/////////////////////////////////////////////////////////////////////
	// 必須アイテム登録
	/////////////////////////////////////////////////////////////////////
	AddReqItems( "The Phlogistinator", "0" );

	/////////////////////////////////////////////////////////////////////
	// カスタムアトリビュート登録
	/////////////////////////////////////////////////////////////////////
	new String:nowValuve[32];
	GetConVarString( g_CVarTBlastDMG, nowValuve, sizeof( nowValuve ) );
	AddCustomAttributes( IS_Primary, "dmg taken from blast increased", nowValuve);
}

/////////////////////////////////////////////////////////////////////
//
// プラグイン開始
//
/////////////////////////////////////////////////////////////////////
public OnPluginStart()
{
	/////////////////////////////////////////////////////////////////////
	// ConVar初期化
	/////////////////////////////////////////////////////////////////////
	CVarInit( PL_NAME, PL_VERSION );
	
	/////////////////////////////////////////////////////////////////////
	// ConVar登録
	/////////////////////////////////////////////////////////////////////
	AddCVar( g_CVarChargeTime,	"charge_time",		"15.0",	"Pyro Power charge time",	0,		"0.0",	"60.0",		FMT_Float);
	AddCVar( g_CVarTBlastDMG,	"tblast_damage",	"1.1",	"dmg taken from blast increased",	0,		"1.0",	"5.0",		FMT_Float);

	/////////////////////////////////////////////////////////////////////
	// 隠れボイス
	/////////////////////////////////////////////////////////////////////
	SOUND_HIDE_VOICE[0] = "vo/pyro_laughevil02.wav";
	SOUND_HIDE_VOICE[1] = "vo/pyro_autoonfire02.wav";
	SOUND_HIDE_VOICE[2] = "vo/pyro_laughevil04.wav";
	SOUND_HIDE_VOICE[3] = "vo/pyro_goodjob01.wav";
	SOUND_HIDE_VOICE[4] = "vo/pyro_laughevil03.wav";
	/////////////////////////////////////////////////////////////////////
	// 登場ボイス
	/////////////////////////////////////////////////////////////////////
	SOUND_UNHIDE_VOICE[0] = "vo/pyro_battlecry01.wav";
	SOUND_UNHIDE_VOICE[1] = "vo/pyro_battlecry02.wav";
	SOUND_UNHIDE_VOICE[2] = "vo/pyro_cheers01.wav";
	SOUND_UNHIDE_VOICE[3] = "vo/pyro_helpme01.wav";
	SOUND_UNHIDE_VOICE[4] = "vo/pyro_laughevil01.wav";
	/////////////////////////////////////////////////////////////////////
	// 隠れ開始ボイス
	/////////////////////////////////////////////////////////////////////
	SOUND_START_VOICE[0] = "vo/pyro_positivevocalization01.wav";
	SOUND_START_VOICE[1] = "vo/pyro_specialcompleted01.wav";
	SOUND_START_VOICE[2] = "vo/pyro_standonthepoint01.wav";
	SOUND_START_VOICE[3] = "vo/pyro_autocappedintelligence01.wav";
	SOUND_START_VOICE[4] = "vo/pyro_autodejectedtie01.wav";
	
	/////////////////////////////////////////////////////////////////////
	// サウンドフック(ロッカー) 
	/////////////////////////////////////////////////////////////////////
//	AddNormalSoundHook( HookResupplySound );		
	/////////////////////////////////////////////////////////////////////
	// リサプライ
	/////////////////////////////////////////////////////////////////////
	HookEvent("post_inventory_application", Event_Resupply);
	
	/////////////////////////////////////////////////////////////////////
	// ActionItemコマンド登録
	/////////////////////////////////////////////////////////////////////
	RegConsoleCmd("use_action_slot_item_server", Command_ActionItem);
	
	/////////////////////////////////////////////////////////////////////
	// イベント登録
	/////////////////////////////////////////////////////////////////////
	HookEvent( "player_spawn", 		EventPlayerReset, 	EventHookMode_Post);	// プレイヤー復活
	HookEvent( "player_death", 		EventPlayerReset, 	EventHookMode_Post);	// プレイヤー死亡
}
/////////////////////////////////////////////////////////////////////
//
// マップ開始
//
/////////////////////////////////////////////////////////////////////
public OnMapStart()
{
	/////////////////////////////////////////////////////////////////////
	// サウンド,モデルプレキャッシュ
	/////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////
	// モデル読み込み
	/////////////////////////////////////////////////////////////////////
	PrecacheModel(MDL_WOODEN_BARREL, true);
	
	/////////////////////////////////////////////////////////////////////
	//サウンド読み込み
	/////////////////////////////////////////////////////////////////////
	PrecacheSound(SOUND_SPAWN_BARREL, true);
	PrecacheSound(SOUND_CHARGE_POWER, true);
	PrecacheSound(SOUND_NO_POWER, true);
	PrecacheSound(SOUND_TAUNT, true);
	for( new i = 0; i < 5; i++)
	{
		PrecacheSound(SOUND_HIDE_VOICE[i], true);
		PrecacheSound(SOUND_UNHIDE_VOICE[i], true);
		PrecacheSound(SOUND_START_VOICE[i], true);
	}
}

/////////////////////////////////////////////////////////////////////
// ゲームフレーム
/////////////////////////////////////////////////////////////////////
public OnGameFrame()
{
	/////////////////////////////////////////////////////////////////////
	// クライアント全員分
	/////////////////////////////////////////////////////////////////////
	new maxclients = GetMaxClients();
	for (new client = 1; client <= maxclients; client++)
	{
		/////////////////////////////////////////////////////////////////////
		// クライアント全員分
		/////////////////////////////////////////////////////////////////////
		if( IsValidClient( client, false ) && IsPlayerAlive(client) )
		{
			
			/////////////////////////////////////////////////////////////////////
			// アイテム挑発終わったらOFF
			/////////////////////////////////////////////////////////////////////
			if( g_ActionUse[client] )
			{
				if( !TF2_IsPlayerInCondition(client, TFCond_Taunting) )
				{
					g_ActionUse[client] = false;
				}
			}
			
			/////////////////////////////////////////////////////////////////////
			// このアビリティ選択中？
			/////////////////////////////////////////////////////////////////////
			if( IsSelectedAbility( client ) )
			{
				/////////////////////////////////////////////////////////////////////
				// 能力アクション
				/////////////////////////////////////////////////////////////////////
				DisguiseJutsu(client);
			}
		}
	}	
}

/////////////////////////////////////////////////////////////////////
//
// イベント発動(player_spawn/player_death) 各種データリセット
//
/////////////////////////////////////////////////////////////////////
public Action:EventPlayerReset(Handle:event, const String:name[], bool:dontBroadcast)
{
	/////////////////////////////////////////////////////////////////////
	// クライアントid
	/////////////////////////////////////////////////////////////////////
	new client = GetClientOfUserId( GetEventInt( event, "userid" ) );
	if( client <= 0 )
	{
		return Plugin_Continue;
	}
	
	/////////////////////////////////////////////////////////////////////
	// デッドリンガーの時は抜ける
	/////////////////////////////////////////////////////////////////////
	if( StrEqual( name, "player_death" ) )
	{
		new bool:DeadRingered = bool:(GetEventInt(event, "death_flags") & TF_DEATHFLAG_DEADRINGER);
		if( DeadRingered )
		{
			return Plugin_Continue;
		}
	}
	
	/////////////////////////////////////////////////////////////////////
	// アイテムタウント
	/////////////////////////////////////////////////////////////////////
	g_ActionUse[client] = false;

	/////////////////////////////////////////////////////////////////////
	// 次に使えるまでの時間リセット
	/////////////////////////////////////////////////////////////////////
	g_NextUseTime[client] = 0.0;
	
	/////////////////////////////////////////////////////////////////////
	// ボイスタイマー停止
	/////////////////////////////////////////////////////////////////////
	ClearTimer(g_HideVoicehTimer[client]);
	
	/////////////////////////////////////////////////////////////////////
	// パワーチャージタイマー停止
	/////////////////////////////////////////////////////////////////////
	ClearTimer(g_PowerChargeTimer[client]);
	
	/////////////////////////////////////////////////////////////////////
	// ボイスカウントリセット
	/////////////////////////////////////////////////////////////////////
	HideVoiceCount = 0;
	
	/////////////////////////////////////////////////////////////////////
	// 現在のヘルス保存
	/////////////////////////////////////////////////////////////////////
	g_NowHealth[client] = GetClientHealth(client);
	
	/////////////////////////////////////////////////////////////////////
	// 見える
	/////////////////////////////////////////////////////////////////////
	SetPlayerRenderHide(client, false);

	/////////////////////////////////////////////////////////////////////
	// モデル削除
	/////////////////////////////////////////////////////////////////////
	DeleteModel(client);
	
	/////////////////////////////////////////////////////////////////////
	// リサプライタイマークリア
	/////////////////////////////////////////////////////////////////////
	ClearTimer(g_ResupplyTimer[client]);
	
	/////////////////////////////////////////////////////////////////////
	// キーリセット
	/////////////////////////////////////////////////////////////////////
	SaveKeyTime(client);
	
	return Plugin_Continue;
}

/////////////////////////////////////////////////////////////////////
//
// アビリティの処理
//
/////////////////////////////////////////////////////////////////////
public DisguiseJutsu(any:client)
{
	/////////////////////////////////////////////////////////////////////
	// 発動中なら終了チェック
	/////////////////////////////////////////////////////////////////////
	if( g_IsBarrelActive[client] )
	{
		/////////////////////////////////////////////////////////////////////
		// 終了チェック
		/////////////////////////////////////////////////////////////////////
		EndCheck(client);
	}

	/////////////////////////////////////////////////////////////////////
	// チェック
	/////////////////////////////////////////////////////////////////////
	if( CheckElapsedTime(client, 0.8) )
	{			
		/////////////////////////////////////////////////////////////////////
		// キーを押した時間を保存
		/////////////////////////////////////////////////////////////////////
		if( GetClientButtons(client) & IN_ATTACK3 )
		{				
			/////////////////////////////////////////////////////////////////////
			// キーを押した時間を保存
			/////////////////////////////////////////////////////////////////////
			SaveKeyTime(client);
			/////////////////////////////////////////////////////////////////////
			// 発動
			/////////////////////////////////////////////////////////////////////
			SpawnBarrel(client);
		}
	}
}


/////////////////////////////////////////////////////////////////////
//
// 樽出現
//
/////////////////////////////////////////////////////////////////////
stock SpawnBarrel(any:client)
{
	/////////////////////////////////////////////////////////////////////
	// 武器チェック
	/////////////////////////////////////////////////////////////////////
	if( GetItemDefIndex( TF2_GetCurrentWeapon(client) ) == 594 )
	{
		/////////////////////////////////////////////////////////////////////
		// 発動していなかったら発動
		/////////////////////////////////////////////////////////////////////
		if( !g_IsBarrelActive[client]  )
		{
			/////////////////////////////////////////////////////////////////////
			// まだ使えないならメッセージ
			/////////////////////////////////////////////////////////////////////
			if( g_NextUseTime[client] > GetGameTime() )
			{
				EmitSoundToClient(client, SOUND_NO_POWER, client, _, _, _, 1.0);
				PrintToChat(client, "\x05%T", "MESSAGE_NO_CHARGE", client, g_NextUseTime[client] - GetGameTime());
				return;
			}
			
			/////////////////////////////////////////////////////////////////////
			// しゃがんだ状態・地上・移動していない
			/////////////////////////////////////////////////////////////////////
			if( GetEntityFlags(client) & FL_DUCKING
				&& GetEntityFlags(client) & FL_ONGROUND
				&& !(GetEntityFlags(client) & FL_INWATER)
				&& TF2_GetPlayerSpeed(client) == 0.0
			)
			{
				/////////////////////////////////////////////////////////////////////
				// 発動エフェクト
				/////////////////////////////////////////////////////////////////////
				new Float:pos[3];
				new Float:ang[3];
				ang[0] = -90.0;
				pos[2] = -30.0;
				
				SpawnParticle( EFFECT_BARREL_SPAWN_FLASH, 1.0, _, client, _, pos, ang);
				for(new i = 0; i < 10; i++)
				{
					pos[0] = GetRandomFloat(-5.0, 5.0);
					pos[1] = GetRandomFloat(-5.0, 5.0);
					SpawnParticle( EFFECT_BARREL_SPAWN_SMOKE, 1.0, _, client, _, pos, ang);
				}
				
				/////////////////////////////////////////////////////////////////////
				// 画面を一瞬灰色に。
				/////////////////////////////////////////////////////////////////////
				ScreenFade(client, 50, 50, 50, 255, 100, IN);
				
				/////////////////////////////////////////////////////////////////////
				// 発動サウンド
				/////////////////////////////////////////////////////////////////////
				EmitSoundToAll(SOUND_SPAWN_BARREL, client, _, _, SND_CHANGEPITCH, 1.0, 55);
				EmitSoundToAll(SOUND_START_VOICE[GetRandomInt(0, 4)], client, _, _, _, 1.0);
				
				/////////////////////////////////////////////////////////////////////
				// 樽モデル作成
				/////////////////////////////////////////////////////////////////////
				g_BarrelModel[client] = CreateEntityByName("prop_dynamic");
				if (IsValidEdict(g_BarrelModel[client]))
				{
					new String:tName[32];
					GetEntPropString(client, Prop_Data, "m_iName", tName, sizeof(tName));
					DispatchKeyValue(g_BarrelModel[client], "targetname", "pyro_barrel");
					DispatchKeyValue(g_BarrelModel[client], "parentname", tName);
					SetEntityModel(g_BarrelModel[client], MDL_WOODEN_BARREL);
					DispatchSpawn(g_BarrelModel[client]);
					SetVariantInt(99999);
					AcceptEntityInput(g_BarrelModel[client], "SetHealth");	
					/////////////////////////////////////////////////////////////////////
					// モデルをプレイヤーの位置に移動
					/////////////////////////////////////////////////////////////////////
					new Float:Pos[3];
					GetClientAbsOrigin(client, Pos);
					Pos[2] += 30.0;
					TeleportEntity(g_BarrelModel[client], Pos, NULL_VECTOR, NULL_VECTOR);
					
			    }	
				
				/////////////////////////////////////////////////////////////////////
				// プレイヤーを見えなくする
				/////////////////////////////////////////////////////////////////////
				SetPlayerRenderHide(client, true);

				/////////////////////////////////////////////////////////////////////
				// 視点が変わらないよう前の死体を消す
				/////////////////////////////////////////////////////////////////////
				new body = -1;
				while ((body = FindEntityByClassname(body, "tf_ragdoll")) != -1)
				{
					new iOwner = GetEntProp(body, Prop_Send, "m_iPlayerIndex");
					if(iOwner == client)
					{
						AcceptEntityInput(body, "Kill");
					}
				}

				/////////////////////////////////////////////////////////////////////
				// 三人称視点
				/////////////////////////////////////////////////////////////////////
				SetEntPropEnt(client, Prop_Data, "m_hObserverTarget", client);
				SetEntProp(client, Prop_Data, "m_iObserverMode", 1);
			
				/////////////////////////////////////////////////////////////////////
				// ボイスタイマー発動
				/////////////////////////////////////////////////////////////////////
				ClearTimer(g_HideVoicehTimer[client]);
				g_HideVoicehTimer[client] = CreateTimer(3.5, Timer_HideVoiceTimer, client, TIMER_REPEAT);
				
				/////////////////////////////////////////////////////////////////////
				// ボイスカウントリセット
				/////////////////////////////////////////////////////////////////////
				HideVoiceCount = 0;

				/////////////////////////////////////////////////////////////////////
				// 現在のヘルスを保存
				/////////////////////////////////////////////////////////////////////
				g_NowHealth[client] = GetClientHealth(client);

				/////////////////////////////////////////////////////////////////////
				// 樽の中に入った
				/////////////////////////////////////////////////////////////////////
				g_IsBarrelActive[client] = true;
			}
		}
	}
}

/////////////////////////////////////////////////////////////////////
//
// 隠れさせる(見えなくする)
//
/////////////////////////////////////////////////////////////////////
stock SetPlayerRenderHide(any:client, bool:hide)
{
	/////////////////////////////////////////////////////////////////////
	// 透明にする
	/////////////////////////////////////////////////////////////////////
	if( hide )
	{
		/////////////////////////////////////////////////////////////////////
		// プレイヤー
		/////////////////////////////////////////////////////////////////////
		SetEntityRenderMode(client, RENDER_TRANSCOLOR);
		SetEntityRenderColor(client, 255, 255, 255, 0);
		
		/////////////////////////////////////////////////////////////////////
		// 武器
		/////////////////////////////////////////////////////////////////////
		for(new i = 0; i < 3; i++)
		{
			new weaponIndex = GetPlayerWeaponSlot(client, i);
			if( weaponIndex != -1 )
			{
				SetEntityRenderMode(weaponIndex, RENDER_TRANSCOLOR);
				SetEntityRenderColor(weaponIndex, 255, 255, 255, 0);
			}
		}	
		
		/////////////////////////////////////////////////////////////////////
		// 帽子
		/////////////////////////////////////////////////////////////////////
		new hat = -1;
		while ((hat = FindEntityByClassname(hat, "tf_wearable")) != -1)
		{
			new iOwner = GetEntPropEnt(hat, Prop_Send, "m_hOwnerEntity");
			if(iOwner == client)
			{
				SetEntityRenderMode(hat, RENDER_TRANSCOLOR);
				SetEntityRenderColor(hat, 255, 255, 255, 0);
			}
		}
	}
	else
	{
		/////////////////////////////////////////////////////////////////////
		// プレイヤー
		/////////////////////////////////////////////////////////////////////
		SetEntityRenderMode(client, RENDER_NORMAL);
		SetEntityRenderColor(client, 255, 255, 255, 255);
		
		/////////////////////////////////////////////////////////////////////
		// 武器
		/////////////////////////////////////////////////////////////////////
		for(new i = 0; i < 3; i++)
		{
			new weaponIndex = GetPlayerWeaponSlot(client, i);
			if( weaponIndex != -1 )
			{
				SetEntityRenderMode(weaponIndex, RENDER_TRANSCOLOR);
				SetEntityRenderColor(weaponIndex, 255, 255, 255, 255);
			}
		}		
		
		/////////////////////////////////////////////////////////////////////
		// 帽子
		/////////////////////////////////////////////////////////////////////
		new hat = -1;
		while ((hat = FindEntityByClassname(hat, "tf_wearable")) != -1)
		{
			new iOwner = GetEntPropEnt(hat, Prop_Send, "m_hOwnerEntity");
			if(iOwner == client)
			{
				SetEntityRenderMode(hat, RENDER_TRANSCOLOR);
				SetEntityRenderColor(hat, 255, 255, 255, 255);
			}
		}
	}
}

/////////////////////////////////////////////////////////////////////
//
// ボイスタイマー
//
/////////////////////////////////////////////////////////////////////
public Action:Timer_HideVoiceTimer(Handle:timer, any:client)
{
	/////////////////////////////////////////////////////////////////////
	// 発動中ならチェック
	/////////////////////////////////////////////////////////////////////
	if(g_IsBarrelActive[client])
	{
		if( IsClientInGame(client) && IsPlayerAlive(client) && !TF2_IsPlayerInCondition(client, TFCond_Taunting) )
		{
			EmitSoundToAll(SOUND_HIDE_VOICE[HideVoiceCount], client, _, _, _, 1.0);
			HideVoiceCount++;
			if(HideVoiceCount > 4)
			{
				HideVoiceCount = 0;
			}
			
		}
	}
	else
	{
		/////////////////////////////////////////////////////////////////////
		// ボイスタイマー削除
		/////////////////////////////////////////////////////////////////////
		ClearTimer(g_HideVoicehTimer[client]);
	}

}

/////////////////////////////////////////////////////////////////////
//
// 発動終了チェック
//
/////////////////////////////////////////////////////////////////////
stock EndCheck(any:client)
{
	/////////////////////////////////////////////////////////////////////
	// 移動・攻撃または立つ・地上以外は解除
	/////////////////////////////////////////////////////////////////////
	if( GetClientButtons(client) & IN_ATTACK 
		|| GetClientButtons(client) & IN_ATTACK2
		|| GetEntityFlags(client) & FL_INWATER 
		|| !(GetEntityFlags(client) & FL_DUCKING)
		|| !(GetEntityFlags(client) & FL_ONGROUND)
	) 
	{
		/////////////////////////////////////////////////////////////////////
		// ボイスタイマー停止
		/////////////////////////////////////////////////////////////////////
		ClearTimer(g_HideVoicehTimer[client]);

		/////////////////////////////////////////////////////////////////////
		// プレイヤーが解除したならボイス出す
		/////////////////////////////////////////////////////////////////////
		if( IsPlayerAlive(client) && GetEntityFlags(client) & FL_ONGROUND )
		{
			/////////////////////////////////////////////////////////////////////
			// 挑発解除は特殊効果
			/////////////////////////////////////////////////////////////////////
			if( !g_ActionUse[client] && TF2_IsPlayerInCondition(client, TFCond_Taunting) )
			{
				EmitSoundToAll(SOUND_TAUNT, client, _, _, SND_CHANGEPITCH, 1.0, 120);
			}
			else
			{
				EmitSoundToAll(SOUND_UNHIDE_VOICE[GetRandomInt(0, 4)], client, _, _, _, 1.0);
			}
		}
		
		/////////////////////////////////////////////////////////////////////
		// 見える
		/////////////////////////////////////////////////////////////////////
		SetPlayerRenderHide(client, false);

		/////////////////////////////////////////////////////////////////////
		// 視点を戻す
		/////////////////////////////////////////////////////////////////////
		SetEntProp(client, Prop_Send, "m_iObserverMode", 0);
		
		/////////////////////////////////////////////////////////////////////
		// モデル削除
		/////////////////////////////////////////////////////////////////////
		DeleteModel(client);
		
		/////////////////////////////////////////////////////////////////////
		// 速度戻す
		/////////////////////////////////////////////////////////////////////
//		TF2_SetPlayerDefaultSpeed(client);
		
		/////////////////////////////////////////////////////////////////////
		// 次に使用可能になるまでの時間設定
		/////////////////////////////////////////////////////////////////////
		g_NextUseTime[client] = GetGameTime() + GetConVarFloat(g_CVarChargeTime);
				
		/////////////////////////////////////////////////////////////////////
		// パワーチャージタイマー発動
		/////////////////////////////////////////////////////////////////////
		ClearTimer(g_PowerChargeTimer[client]);
		g_PowerChargeTimer[client] = CreateTimer(GetConVarFloat(g_CVarChargeTime), Timer_PowerChargeTimer, client);
		//g_PowerChargeTimer[client] = CreateTimer(15.0, Timer_PowerChargeTimer, client);
		
		/////////////////////////////////////////////////////////////////////
		// 動ける
		/////////////////////////////////////////////////////////////////////
		SetEntityMoveType(client, MOVETYPE_WALK);
	}
	else
	{
		/////////////////////////////////////////////////////////////////////
		// もしプレイヤーが移動したら樽も移動
		/////////////////////////////////////////////////////////////////////
		if( g_BarrelModel[client] != -1 && g_BarrelModel[client] != 0)
		{
			if( IsValidEntity(g_BarrelModel[client]) )
			{
				new Float:Pos[3];
				GetClientAbsOrigin(client, Pos);
				Pos[2] += 30.0;
				TeleportEntity(g_BarrelModel[client], Pos, NULL_VECTOR, NULL_VECTOR);
			}
		}
		
		/////////////////////////////////////////////////////////////////////
		// 動けない
		/////////////////////////////////////////////////////////////////////
		SetEntityMoveType(client, MOVETYPE_NONE);
//		TF2_SetPlayerSpeed(client, 0.5);
		
	}
	
}

/////////////////////////////////////////////////////////////////////
//
// パワーチャージ完了
//
/////////////////////////////////////////////////////////////////////
public Action:Timer_PowerChargeTimer(Handle:timer, any:client)
{
	g_PowerChargeTimer[client] = INVALID_HANDLE;
	
	/////////////////////////////////////////////////////////////////////
	// 次に使える時間リセット
	/////////////////////////////////////////////////////////////////////
	g_NextUseTime[client] = GetGameTime()
	
	/////////////////////////////////////////////////////////////////////
	// ゲームに入っている
	/////////////////////////////////////////////////////////////////////
	if( IsClientInGame(client) && IsPlayerAlive(client))
	{
		PrintToChat(client, "\x05%T", "MESSAGE_POWER_CHARGED", client);
		EmitSoundToClient(client, SOUND_CHARGE_POWER, client, _, _, _, 1.0);
	}
}

/////////////////////////////////////////////////////////////////////
//
// 樽破壊
//
/////////////////////////////////////////////////////////////////////
stock BreakBarrel(any:client)
{
	/////////////////////////////////////////////////////////////////////
	// 樽の破片
	/////////////////////////////////////////////////////////////////////
	new gibModel = CreateEntityByName("prop_physics_override");
	if (IsValidEdict(gibModel))
	{
		SetEntityModel(gibModel, MDL_WOODEN_BARREL);
		DispatchSpawn(gibModel);
		
		
		/////////////////////////////////////////////////////////////////////
		// モデルをプレイヤーの位置に移動
		/////////////////////////////////////////////////////////////////////
		new Float:pos[3];
		GetEntPropVector(client, Prop_Data, "m_vecAbsOrigin", pos);
		pos[2] += 30.0;
		new Float:ang[3];
		GetClientEyeAngles(client, ang);
		ang[0] = 0.0;
		ang[1] += 40.0;
		ang[2] = 0.0;
		TeleportEntity(gibModel, pos, ang, NULL_VECTOR);
		AcceptEntityInput(gibModel, "Break");
		AcceptEntityInput(gibModel, "Kill");
	}	
}


/////////////////////////////////////////////////////////////////////
//
// モデル削除
//
/////////////////////////////////////////////////////////////////////
stock DeleteModel(any:client)
{
	/////////////////////////////////////////////////////////////////////
	// モデルを削除
	/////////////////////////////////////////////////////////////////////
	if( g_BarrelModel[client] != -1 && g_BarrelModel[client] != 0)
	{
		if( IsValidEntity(g_BarrelModel[client]) )
		{
			/////////////////////////////////////////////////////////////////////
			// 樽破壊
			/////////////////////////////////////////////////////////////////////
			BreakBarrel(client);

			AcceptEntityInput( g_BarrelModel[ client ], "Kill" );
			g_BarrelModel[client] = -1;
		}	
	}
	
	g_IsBarrelActive[client] = false;
}

/////////////////////////////////////////////////////////////////////
//
// リサプライエリアにIN
//
/////////////////////////////////////////////////////////////////////
/*public Action:HookResupplySound( clients[64], &numClients, String:sample[PLATFORM_MAX_PATH], &entity, &channel, &Float:volume, &level, &pitch, &flags)
{
	/////////////////////////////////////////////////////////////////////
	// 音チェック
	/////////////////////////////////////////////////////////////////////
	if( !StrEqual( sample, "items/regenerate.wav", true ) )
	{
		return Plugin_Continue;
	}
	
	/////////////////////////////////////////////////////////////////////
	// ロッカーじゃないなら抜ける
	/////////////////////////////////////////////////////////////////////
	new String:name[64];
	GetEdictClassname( entity, name, 64 );
	if( !StrEqual( name,  "player" ) )
	{
		return Plugin_Continue;
	}

	/////////////////////////////////////////////////////////////////////
	// イベント発生
	/////////////////////////////////////////////////////////////////////
	for( new i = 0; i < numClients + 1; i++ )
	{
		if( i == entity && i != 0 )
		{
			/////////////////////////////////////////////////////////////////////
			// ちょっと遅延
			/////////////////////////////////////////////////////////////////////
			ClearTimer( g_ResupplyTimer[ i ] );
			g_ResupplyTimer[ i ] = CreateTimer( 0.1, Timer_Resupply, i );
			
		}
	}
	
	return Plugin_Continue;
}

public Action:Timer_Resupply(Handle:timer, any:client)
{
	g_ResupplyTimer[ client ] = INVALID_HANDLE;
	
	if( IsValidClient( client, false ) && IsPlayerAlive(client) )
	{
		/////////////////////////////////////////////////////////////////////
		// アビリティ使用中
		/////////////////////////////////////////////////////////////////////
		if( IsSelectedAbility( client ) )
		{
			/////////////////////////////////////////////////////////////////////
			// ロッカーに触るとチャージ
			/////////////////////////////////////////////////////////////////////
			if( g_PowerChargeTimer[client] != INVALID_HANDLE )
			{
				ClearTimer(g_PowerChargeTimer[client]);
				Timer_PowerChargeTimer( INVALID_HANDLE, client );
			}
		}
	
	}
}*/

/////////////////////////////////////////////////////////////////////
//
// リサプライ
//
/////////////////////////////////////////////////////////////////////
public Action:Event_Resupply(Handle:hEvent, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(hEvent, "userid"));
	g_ResupplyTimer[ client ] = INVALID_HANDLE;
	
	if( IsValidClient( client, false ) && IsPlayerAlive(client) )
	{
		/////////////////////////////////////////////////////////////////////
		// アビリティ使用中
		/////////////////////////////////////////////////////////////////////
		if( IsSelectedAbility( client ) )
		{
			/////////////////////////////////////////////////////////////////////
			// ロッカーに触るとチャージ
			/////////////////////////////////////////////////////////////////////
			if( g_PowerChargeTimer[client] != INVALID_HANDLE )
			{
				ClearTimer(g_PowerChargeTimer[client]);
				Timer_PowerChargeTimer( INVALID_HANDLE, client );
			}
		}
	
	}	
	return Plugin_Continue;
}  


/////////////////////////////////////////////////////////////////////
//
// アクションスロット
//
/////////////////////////////////////////////////////////////////////
public Action:Command_ActionItem(client, args)
{
	if( IsRunning() )
	{
		/////////////////////////////////////////////////////////////////////
		// アクションアイテム使用
		/////////////////////////////////////////////////////////////////////
		g_ActionUse[client] = true;
	}
	return Plugin_Continue;
}
