/////////////////////////////////////////////////////////////////////
//
// item helper
//
/////////////////////////////////////////////////////////////////////
#if defined _rmf_itemhelper_included
#endinput
#endif
#define _rmf_itemhelper_included

native Handle:PrepareItemHandle( weaponLookupIndex, bool:_removeBaseAttr = false );

native _:GetItemDefIndex( entIndex );
native _:GetItemDefIndexFromName( const String:name[] );
native _:GetItemSlot( entIndex );
native _:GetItemSlotFromDefIndex( itemIndex );

native _:GetAttributeIndexFromName( const String:attrName[] );
native _:GetEffectIndexFromName( const String:particleName[] );

native GetItemDisplayName( itemIndex, client, String:itemName[], maxlength );

native bool:ClearItemAttribute( Handle:hItem );
native bool:SetAttribute( Handle:hItem, slot, atrIndex, const String:value[] );
native bool:AddAttribute( Handle:hItem, atrIndex, const String:value[] );
native bool:SetItemAttribute( Handle:hItem, slot, const String:attrName[], const String:value[] );
native bool:AddItemAttribute( Handle:hItem, const String:attrName[], const String:value[] );

native _:RMFIH_GiveWeapon( client, const String:weaponName[], const String:_attrSetting[] = "", bool:_removeBaseAttr = false );
native RMFIH_AttrSetAdd( String:_attrSet[], const String:_attrName[], const String:_attrValue[] );

public SharedPlugin:__pl_itemhelper = 
{
	name = "[RMF] Item Helper",
	file = "RMFItemHelper.smx",
#if defined REQUIRE_PLUGIN
	required = 1,#else
	required = 0,
#endif
};

#if !defined REQUIRE_PLUGIN
public __pl_itemhelper_SetNTVOptional() {
	MarkNativeAsOptional("PrepareItemHandle");
	
	MarkNativeAsOptional("GetItemDefIndex");
	MarkNativeAsOptional("GetItemDefIndexFromName");
	MarkNativeAsOptional("GetItemSlot");
	MarkNativeAsOptional("GetItemSlotFromItemDefIndex");
	MarkNativeAsOptional("GetAttributeIndexFromName");
	MarkNativeAsOptional("GetEffectIndexFromName");
	
	MarkNativeAsOptional("GetItemDisplayName");
	
	MarkNativeAsOptional("ClearItemAttribute");
	MarkNativeAsOptional("SetAttribute");
	MarkNativeAsOptional("AddAttribute");
	MarkNativeAsOptional("SetItemAttribute");
	MarkNativeAsOptional("AddItemAttribute");
	
	MarkNativeAsOptional("RMFIH_GiveWeapon");
	MarkNativeAsOptional("RMFIH_AttrSetAdd");
	
}
#endif


/////////////////////////////////////////////////////////////////////
//
// \̃ACeIDQbg
//
/////////////////////////////////////////////////////////////////////
public _:GetSameWeaponIndex( _intemIndex, TFClassType:_playerClass)
{
	switch( _intemIndex )
	{
	// XJb^[K
	case 200: {	_intemIndex = 13;	}
	case 669: {	_intemIndex = 13;	}
	case 799: {	_intemIndex = 13;	}
	case 808: {	_intemIndex = 13;	}
	case 888: {	_intemIndex = 13;	}
	case 897: {	_intemIndex = 13;	}
	case 906: {	_intemIndex = 13;	}
	case 915: {	_intemIndex = 13;	}
	case 964: {	_intemIndex = 13;	}
	case 973: {	_intemIndex = 13;	}
	// obg
	case 190: {	_intemIndex = 0;	}
	case 660: {	_intemIndex = 0;	}
	// Holy Mackerel
	case 1078: {	_intemIndex = 45;	}
	// Holy Mackerel
	case 999: {	_intemIndex = 221;	}
	// Pbg`[
	case 205: {	_intemIndex = 18;	}
	case 658: {	_intemIndex = 18;	}
	case 800: {	_intemIndex = 18;	}
	case 809: {	_intemIndex = 18;	}
	case 889: {	_intemIndex = 18;	}
	case 898: {	_intemIndex = 18;	}
	case 916: {	_intemIndex = 18;	}
	case 965: {	_intemIndex = 18;	}
	case 974: {	_intemIndex = 18;	}
	// Black Box
	case 1085: {	_intemIndex = 228;	}
	// Buff Banner
	case 1001: {	_intemIndex = 129;	}
	// Vx
	case 196: {	_intemIndex = 6;	}
	// Ήˊ
	case 208: {	_intemIndex = 21;	}
	case 659: {	_intemIndex = 21;	}
	case 741: {	_intemIndex = 21;	}
	case 798: {	_intemIndex = 21;	}
	case 807: {	_intemIndex = 21;	}
	case 887: {	_intemIndex = 21;	}
	case 896: {	_intemIndex = 21;	}
	case 905: {	_intemIndex = 21;	}
	case 914: {	_intemIndex = 21;	}
	case 972: {	_intemIndex = 21;	}
	// tAK
	case 1081: {	_intemIndex = 39;	}
	// h
	case 192: {	_intemIndex = 2;	}
	// Ε
	case 1000: {	_intemIndex = 38;	}
	// Neon Annihilator
	case 834: {	_intemIndex = 813;	}
	// Ol[h`[
	case 206: {	_intemIndex = 19;	}
	case 1007: {	_intemIndex = 19;	}
	// C
	case 608: {	_intemIndex = 405;	}
	// Se`[
	case 207: {	_intemIndex = 20;	}
	case 661: {	_intemIndex = 20;	}
	case 797: {	_intemIndex = 20;	}
	case 806: {	_intemIndex = 20;	}
	case 886: {	_intemIndex = 20;	}
	case 895: {	_intemIndex = 20;	}
	case 904: {	_intemIndex = 20;	}
	case 913: {	_intemIndex = 20;	}
	case 962: {	_intemIndex = 20;	}
	case 971: {	_intemIndex = 20;	}
	// {g
	case 191: {	_intemIndex = 1;	}
	// Eyelander
	case 1082: {	_intemIndex = 132;	}
	// ~jK
	case 202: {	_intemIndex = 15;	}
	case 654: {	_intemIndex = 15;	}
	case 793: {	_intemIndex = 15;	}
	case 802: {	_intemIndex = 15;	}
	case 882: {	_intemIndex = 15;	}
	case 891: {	_intemIndex = 15;	}
	case 900: {	_intemIndex = 15;	}
	case 909: {	_intemIndex = 15;	}
	case 958: {	_intemIndex = 15;	}
	case 867: {	_intemIndex = 15;	}
	// The Huo Long Heatmaker 
	case 832: {	_intemIndex = 811;	}
	// ThBb`
	case 863: {	_intemIndex = 42;	}
	case 1002: {	_intemIndex = 42;	}
	// 
	case 195: {	_intemIndex = 5;	}
	// GRU
	case 1084: {	_intemIndex = 239;	}
	// Frontier Justice 
	case 1004: {	_intemIndex = 141;	}
	// Wrangler
	case 1086: {	_intemIndex = 140;	}
	// `
	case 197: {	_intemIndex = 7;	}
	case 169: {	_intemIndex = 7;	}
	case 662: {	_intemIndex = 7;	}
	case 795: {	_intemIndex = 7;	}
	case 804: {	_intemIndex = 7;	}
	case 884: {	_intemIndex = 7;	}
	case 893: {	_intemIndex = 7;	}
	case 902: {	_intemIndex = 7;	}
	case 911: {	_intemIndex = 7;	}
	case 960: {	_intemIndex = 7;	}
	case 969: {	_intemIndex = 7;	}
	// PDA
	case 737: {	_intemIndex = 25;	}
	// VWK
	case 204: {	_intemIndex = 17;	}
	// NX{E
	case 1079: {	_intemIndex = 305;	}
	// fB
	case 211: {	_intemIndex = 29;	}
	case 663: {	_intemIndex = 29;	}
	case 796: {	_intemIndex = 29;	}
	case 805: {	_intemIndex = 29;	}
	case 885: {	_intemIndex = 29;	}
	case 894: {	_intemIndex = 29;	}
	case 903: {	_intemIndex = 29;	}
	case 912: {	_intemIndex = 29;	}
	case 961: {	_intemIndex = 29;	}
	case 970: {	_intemIndex = 29;	}
	// pmR
	case 198: {	_intemIndex = 8;	}
	// Ubersaaw
	case 1003: {	_intemIndex = 37;	}
	// XiCp[Ct
	case 201: {	_intemIndex = 14;	}
	case 664: {	_intemIndex = 14;	}
	case 792: {	_intemIndex = 14;	}
	case 801: {	_intemIndex = 14;	}
	case 851: {	_intemIndex = 14;	}
	case 881: {	_intemIndex = 14;	}
	case 890: {	_intemIndex = 14;	}
	case 899: {	_intemIndex = 14;	}
	case 908: {	_intemIndex = 14;	}
	case 957: {	_intemIndex = 14;	}
	case 966: {	_intemIndex = 14;	}
	// Huntsman
	case 1005: {	_intemIndex = 56;	}
	// SMG
	case 203: {	_intemIndex = 16;	}
	// SMG
	case 1083: {	_intemIndex = 58;	}
	// NN
	case 193: {	_intemIndex = 3;	}
	// {o[
	case 210: {	_intemIndex = 24;	}
	// Ambassador
	case 1006: {	_intemIndex = 61;	}
	// PDA
	case 736: {	_intemIndex = 735;	}
	case 1080: {	_intemIndex = 735;	}
	// Red Tape
	case 831: {	_intemIndex = 810;	}
	// iCt
	case 194: {	_intemIndex = 4;	}
	case 665: {	_intemIndex = 4;	}
	case 794: {	_intemIndex = 4;	}
	case 803: {	_intemIndex = 4;	}
	case 883: {	_intemIndex = 4;	}
	case 892: {	_intemIndex = 4;	}
	case 901: {	_intemIndex = 4;	}
	case 910: {	_intemIndex = 4;	}
	case 959: {	_intemIndex = 4;	}
	case 968: {	_intemIndex = 4;	}
	// v
	case 212: {	_intemIndex = 30;	}
	// sXg
	case 209: {	
		if( _playerClass == TFClass_Scout )
		{
			// XJEg
			_intemIndex = 23;
		}
		else if( _playerClass == TFClass_Engineer )
		{
			// GW
			_intemIndex = 22;
		}
	}
	// VbgK
	case 199: {	
		if( _playerClass == TFClass_Soldier )
		{
			// \W[
			_intemIndex = 10;
		}
		else if( _playerClass == TFClass_Pyro )
		{
			// pC
			_intemIndex = 12;
		}
		else if( _playerClass == TFClass_Heavy )
		{
			// wr[
			_intemIndex = 11;
		}
		else if( _playerClass == TFClass_Engineer )
		{
			// GW
			_intemIndex = 9;
		}
	}
	default: {}
	}			
	
	return _intemIndex;
}




